#include <MozziGuts.h>
#include <Oscil.h> // oscillator 
#include <tables/cos2048_int8.h> // table for Oscils to play
#include <AutoMap.h> // maps unpredictable inputs to a range
 
// desired carrier frequency max and min, for AutoMap
const int MIN_CARRIER_FREQ = 1220;
const int MAX_CARRIER_FREQ = 200;

// desired intensity max and min, for AutoMap, note they're inverted for reverse dynamics
const int MIN_INTENSITY = 700;
const int MAX_INTENSITY = 10;

AutoMap kMapCarrierFreq(0,1023,MIN_CARRIER_FREQ,MAX_CARRIER_FREQ);
AutoMap kMapIntensity(0,1023,MIN_INTENSITY,MAX_INTENSITY);
float carrier_freq = 333; //oscillator frequency
float carrier_freq2 = 333; //frequency after octave button


const int pitch_PIN = A3; // set the input for the knob to analog pin 0
const int mod_PIN = A2; // set the input for the LDR to analog pin 1
int SWITCH =3;//SWITCH PIN
Oscil<COS2048_NUM_CELLS, AUDIO_RATE> aCarrier(COS2048_DATA);
Oscil<COS2048_NUM_CELLS, AUDIO_RATE> aModulator(COS2048_DATA);

int mod_ratio = 3; // harmonics
long fm_intensity; // carries control info from updateControl() to updateAudio()



//////////////////
float gamTone = 0; 



float gamArray[8]{204.40, 408.81, 433.51, 597.81, 648.19, 820.33,872.61,1198.57};
//int gamArray[10]{204.40, 408.81, 433.51, 597.81, 648.19, 820.33,872.61,1198.57};


   int Soundpin = 9;
  //int timing = 47;//length of note

  int testA0 = analogRead(A0); 
int testA1 = analogRead(A1); 
int testA2 = analogRead(A2); 
int testA3 = analogRead(A3); 
int testA4 = analogRead(A4);
int testA5 = analogRead(A5); 
//BUTTONS NEXT WHEN NEEDED
//int testD4 = digitalRead(4); 
char killswitchD4 = LOW;//digitalRead(4)
int volumeCont= 0; //volume control
char MorseswitchD10 = LOW; //int testD10 = digitalRead(10);
//buttons
char octaveD5 = LOW;//digitalRead(5)
int testD9 = digitalRead(9); 

int testD11 = digitalRead(11);

int gammaSwitchD12 = digitalRead(12);
//int testD12 = digitalRead(12);



void setup() {
  Serial.begin(9600); // set up the Serial output so we can look at the piezo values // set up the Serial output for debugging
  startMozzi(); // :))
}




//////////////////////////////////////////////








void updateControl(){
volumeCont = 1;
  
  // read the knob
  int pitch_value = mozziAnalogRead(pitch_PIN); // value is 0-1023

 gammaSwitchD12 = digitalRead(SWITCH);
 if(gammaSwitchD12 == HIGH){
int pitch_value2 = map(pitch_value,1111, 0, 0, 7);//gamescale sellector
   //gamarray pitches
carrier_freq = gamArray[pitch_value2];}
  
 if(gammaSwitchD12 == LOW){
 // map the knob to carrier frequency
carrier_freq = kMapCarrierFreq(pitch_value);}


  //calculate the modulation frequency to stay in ratio
  int mod_freq = carrier_freq * mod_ratio;


    // set the FM oscillator frequencies to the calculated values
    //VOLUME FOR THE KILL SWITCH - CUT THE FREQUENCY TO ZERO
    carrier_freq2 = carrier_freq/2;
  aCarrier.setFreq((carrier_freq2)* volumeCont);
    
  
 
  
  // set the FM oscillator frequencies to the calculated values
 // aCarrier.setFreq(carrier_freq);



   
  aModulator.setFreq(mod_freq);
  
  // read the light dependent resistor on the Analog input pin
  int mod_level= mozziAnalogRead(mod_PIN); // value is 0-1023
  
  // print the value to the Serial monitor for debugging
  
  Serial.print("carrier_freq2  = "); 
  Serial.print(carrier_freq2 ); 
  Serial.print("\t"); // prints a tab
  
  
  Serial.print("mod_freq = "); 
  Serial.print(mod_freq); 
  Serial.print("\t"); // prints a tab
  
  fm_intensity = kMapIntensity(mod_level);
  
  Serial.print("fm_intensity = ");
  Serial.print(fm_intensity);
  Serial.println(); // print a carraige return for the next line of debugging info

}


int updateAudio(){
  long modulation = (fm_intensity * aModulator.next())* volumeCont; 
  return aCarrier.phMod(modulation); // phMod does the FM
}


























//////////////////////////////////
void loop() {



audioHook();

}












