#include <MozziGuts.h>
#include <Oscil.h> // oscillator 
#include <tables/cos2048_int8.h> // table for Oscils to play
#include <AutoMap.h> // maps unpredictable inputs to a range
 
// desired carrier frequency max and min, for AutoMap
const int MIN_CARRIER_FREQ = 1220;
const int MAX_CARRIER_FREQ = 200;

// desired intensity max and min, for AutoMap, note they're inverted for reverse dynamics
const int MIN_INTENSITY = 700;
const int MAX_INTENSITY = 10;

AutoMap kMapCarrierFreq(0,1023,MIN_CARRIER_FREQ,MAX_CARRIER_FREQ);
AutoMap kMapIntensity(0,1023,MIN_INTENSITY,MAX_INTENSITY);
float carrier_freq = 333; //oscillator frequency
float carrier_freq2 = 333; //frequency after octave button
const int pitch_PIN = 1; // set the input for the knob to analog pin 0
const int mod_PIN = 0; // set the input for the LDR to analog pin 1

Oscil<COS2048_NUM_CELLS, AUDIO_RATE> aCarrier(COS2048_DATA);
Oscil<COS2048_NUM_CELLS, AUDIO_RATE> aModulator(COS2048_DATA);

int mod_ratio = 3; // harmonics
long fm_intensity; // carries control info from updateControl() to updateAudio()



//////////////////
float gamTone = 0; 



float gamArray[8]{204.40, 408.81, 433.51, 597.81, 648.19, 820.33,872.61,1198.57};
//int gamArray[10]{204.40, 408.81, 433.51, 597.81, 648.19, 820.33,872.61,1198.57};


   int Soundpin = 9;
  int timing = 47;//length of note

  int testA0 = analogRead(A0); 
int testA1 = analogRead(A1); 
int testA2 = analogRead(A2); 
int testA3 = analogRead(A3); 
int testA4 = analogRead(A4);
int testA5 = analogRead(A5); 
//BUTTONS NEXT WHEN NEEDED
//int testD4 = digitalRead(4); 
char killswitchD4 = LOW;//digitalRead(4)
int volumeCont= 0; //volume control

//buttons
char octaveD5 = LOW;//digitalRead(5)
int testD9 = digitalRead(9); 
int testD10 = digitalRead(10);
int testD11 = digitalRead(11);

int gammaSwitchD12 = digitalRead(12);
//int testD12 = digitalRead(12);



void setup() {
  Serial.begin(115200); // set up the Serial output so we can look at the piezo values // set up the Serial output for debugging
  startMozzi(); // :))
}




//////////////////////////////////////////////








void updateControl(){
killswitchD4 = digitalRead(4); 
if(killswitchD4 == HIGH){volumeCont = 0;}
if(killswitchD4 == LOW){volumeCont = 1;}
  
  // read the knob
  int pitch_value = mozziAnalogRead(pitch_PIN); // value is 0-1023

 gammaSwitchD12 = digitalRead(12);
 if(gammaSwitchD12 == HIGH){
int pitch_value2 = map(pitch_value,1111, 0, 0, 7);//gamescale sellector
   //gamarray pitches
carrier_freq = gamArray[pitch_value2];}
  
 if(gammaSwitchD12 == LOW){
 // map the knob to carrier frequency
carrier_freq = kMapCarrierFreq(pitch_value);}


  //calculate the modulation frequency to stay in ratio
  int mod_freq = carrier_freq * mod_ratio;

 //OCTAVE SWITCH D5
 // octaveD5 = digitalRead(5);
 octaveD5 = digitalRead(5);
  if(octaveD5 == LOW) {
    // set the FM oscillator frequencies to the calculated values
    //VOLUME FOR THE KILL SWITCH - CUT THE FREQUENCY TO ZERO
    carrier_freq2 = carrier_freq/2;
  aCarrier.setFreq((carrier_freq2)* volumeCont);}
    
  
  //OCTAVE SWITCH D5
  if(octaveD5 == HIGH) {
    // set the FM oscillator frequencies to the calculated values
    carrier_freq2 = carrier_freq;
  aCarrier.setFreq((carrier_freq2)* volumeCont);}
  
  // set the FM oscillator frequencies to the calculated values
 // aCarrier.setFreq(carrier_freq);



   
  aModulator.setFreq(mod_freq);
  
  // read the light dependent resistor on the Analog input pin
  int mod_level= mozziAnalogRead(mod_PIN); // value is 0-1023
  
  // print the value to the Serial monitor for debugging
  
  Serial.print("carrier_freq  = "); 
  Serial.print(carrier_freq ); 
  Serial.print("\t"); // prints a tab
  
  
  Serial.print("light_level = "); 
  Serial.print(mod_level); 
  Serial.print("\t"); // prints a tab
  
  fm_intensity = kMapIntensity(mod_level);
  
  Serial.print("fm_intensity = ");
  Serial.print(fm_intensity);
  Serial.println(); // print a carraige return for the next line of debugging info

}


int updateAudio(){
  long modulation = (fm_intensity * aModulator.next())* volumeCont; 
  return aCarrier.phMod(modulation); // phMod does the FM
}


























//////////////////////////////////
void loop() {



audioHook();

}












////////////////////////////////////////////////////
void gamerplay(int toneNum){

testA0 = analogRead(A0); 
testA1 = analogRead(A1); 
testA2 = analogRead(A2); 
testA3 = analogRead(A3); 
testA4 = analogRead(A4);
testA5 = analogRead(A5); 
//BUTTONS NEXT WHEN NEEDED
killswitchD4 = digitalRead(4); 
octaveD5 = digitalRead(5);

testD9 = digitalRead(9); 
testD10 = digitalRead(10);
testD11 = digitalRead(11);
gammaSwitchD12 = digitalRead(12);
//int testD13 = digitalRead(13);



//MAPPING WHEN NEEDED
testA1 = map(testA1,1111, 0, 0, 7);//gamescale sellector
testA2 = map(testA2,1200, 0, 0, 500);
testA0 = map(testA0,1200, 0, 500, 0);

 //testA3 = map(testA3,1200, 0, 0, 9);
testA4 = map(testA4,1200, 0, 0, 700);
 //testA5 = map(testA5,1200, 0, 0, 9); 

timing = testA4;
//gamerplay(testA1);
  

// do something different depending on the
  // randomnumber1 value:
 gamTone = gamArray[toneNum];
if(gammaSwitchD12 == HIGH){
  gamTone = (gamArray[toneNum] - testA0)+testA2;
}
  if(octaveD5 == HIGH){gamTone = gamTone /2;}
  //divide the gamtone for lower octaves


   // TEST CODE BELOW FOR DEBUGGING
  int testA1B = analogRead(A1); 
 Serial.print("gametone = \t ");
Serial.print(gamTone);//testA1 
 Serial.print("\t toneNum = \t ");
 Serial.print(testA1);//testA1 
//Serial.print(testA1B);//testA1 
Serial.println(">>>>>>>>");


/////////////////////////
//TONE GENERATOR HERE
if(killswitchD4 == HIGH){        // mute tone
tone(Soundpin, gamTone,timing);
delay(timing/2);
noTone(Soundpin);
delay(timing/2);
}

}


